using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Couleurs2
{
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }

  int WCell = 30, HCell = 25;
  int LI, COL = 15;
  Couleur[] tabCoul = new Couleur[] {
     new Couleur("AliceBlue", 130, "F0F8FF"), 
     new Couleur("AntiqueWhite", 116, "FAEBD7"),
//     new Couleur("Aqua", 
//     new Couleur("Aquamarine", 
     new Couleur("Azure", 128, "F0FFFF"),
     new Couleur("Beige", 72, "F5F5DC"),
     new Couleur("Bisque", 119, "FFE4C4"),
     new Couleur("Black", 1, "000000"),
     new Couleur("BlanchedAlmond", 118, "FFEBCD"),
     new Couleur("Blue", 19, "0000FF"),
     new Couleur("BlueViolet", 104, "8A2BE2"),
     new Couleur("Brown", 78, "A52A2A"),
     new Couleur("BurlyWood", 71, "DEB887"),
     new Couleur("CadetBlue", 34, "5F9EA0"),
     new Couleur("Chartreuse", 50, "7FFF00"),
     new Couleur("Chocolate", 76, "D2691E"),
     new Couleur("Coral", 84, "FF7F50"),
//     new Couleur("Cornflower", 
     new Couleur("CornflowerBlue", 13, "6495ED"),
     new Couleur("Cornsilk", 123, "FFF8DC"),
//     new Couleur("Crimson", 
     new Couleur("Cyan", 32, "00FFFF"),
     new Couleur("DarkBlue", 11, "00008B"),
     new Couleur("DarkCyan", 37, "008B8B"),
     new Couleur("DarkGoldenrod", 65, "B8860B"),
//     new Couleur("DarkGray", 
     new Couleur("DarkGray", 4, "A9A9A9"),
     new Couleur("DarkGreen", 38, "006400"),
     new Couleur("DarkKhaki", 58, "BDB76B"),
     new Couleur("DarkMagenta", 107, "8B008B"),
     new Couleur("DarkOliveGreen", 40, "556B2F"),
     new Couleur("DarkOrange", 83, "FF8C00"),
     new Couleur("DarkOrchid", 102, "9932CC"),
     new Couleur("DarkRed", 95, "8B0000"),
     new Couleur("DarkSalmon", 79, "E9967A"),
     new Couleur("DarkSeaGreen", 41, "8FBC8F"),
     new Couleur("DarkSlateBlue", 14, "483D8B"),
     new Couleur("DarkSlateGray", 2, "2F4F4F"),
     new Couleur("DarkTurquoise", 29, "00CED1"),
     new Couleur("DarkViolet", 103, "9400D3"),
     new Couleur("DeepPink", 90, "FF1493"),
     new Couleur("DeepSkyBlue", 21, "00BFFF"),
     new Couleur("DimGray", 3, "696969"), 
     new Couleur("DodgerBlue", 20, "1E90FF"),
     new Couleur("FireBrick", 77, "B22222"),
     new Couleur("FloralWhite", 113, "FFFAF0"),
     new Couleur("ForestGreen", 55, "228B22"),
//     new Couleur("Fuschia",
     new Couleur("Gainsboro", 112, "DCDCDC"),
     new Couleur("GhostWhite", 110, "F8F8FF"),
     new Couleur("Gold", 63, "FFD700"),
     new Couleur("Goldenrod", 64, "DAA520"),
     new Couleur("Gray", 5, "BEBEBE"),
     new Couleur("Green", 56, "008000"),
     new Couleur("GreenYellow", 52, "ADFF2F"),
     new Couleur("Honeydew", 127, "F0FFF0"),
     new Couleur("HotPink", 89, "FF69B4"),
     new Couleur("IndianRed", 67, "CD5C5C"), 
//     new Couleur("Indigo", 
     new Couleur("Ivory", 124, "FFFFF0"),
//     new Couleur("Khaki",
     new Couleur("Lavender", 131, "E6E6FA"),
     new Couleur("LavenderBlush", 132, "FFF0F5"),
     new Couleur("LawnGreen", 48, "7CFC00"),
     new Couleur("LemonChiffon", 125, "FFFACD"),
     new Couleur("LightBlue", 26, "ADD8E6"),
     new Couleur("LightCoral", 85, "F08080"),
     new Couleur("LightCyan", 33, "E0FFFF"),
     new Couleur("LightGoldenrodYellow", 60, "FAFAD2"),
     new Couleur("LightGray", 9, "D3D3D3"),
     new Couleur("LightGreen", 46, "90EE90"),
     new Couleur("LightPink", 92, "FFB6C1"),
     new Couleur("LightSalmon", 81, "FFA07A"),
//     new Couleur("LightSeaGreen",
     new Couleur("LightSkyBlue", 23, "87CEFA"),                                       
     new Couleur("LightSlateGray", 7, "778899"), 
     new Couleur("LightSteelBlue", 25, "B0C4DE"),
     new Couleur("LightYellow", 61, "FFFFE0"),
     new Couleur("Lime", 49, "00FF00"),
     new Couleur("LimeGreen", 53, "32CD32"),
     new Couleur("Linen", 115, "FAF0E6"),
     new Couleur("Magenta", 97, "FF00FF"),
     new Couleur("Maroon", 94, "B03060"),
     new Couleur("MediumAquaMarine", 35, "66CDAA"),
     new Couleur("MediumBlue", 17, "0000CD"),
     new Couleur("MediumOrchid", 101, "BA55D3"),
     new Couleur("MediumPurple", 105, "9370DB"),
     new Couleur("MediumSeaGreen", 43, "3CB371"),
     new Couleur("MediumSlateBlue", 16, "7B68EE"),
     new Couleur("MediumSpringGreen", 51, "00FA9A"),
     new Couleur("MediumTurquoise", 30, "48D1CC"),
     new Couleur("MediumVioletRed", 96, "C71585"), 
     new Couleur("MidnightBlue", 10, "191970"),
     new Couleur("MintCream", 128, "F5FFFA"),
     new Couleur("MistyRose", 133, "FFE4E1"),
     new Couleur("Moccasin", 122, "FFE4B5"),
     new Couleur("NavajoWhite", 121, "FFDEAD"), 
     new Couleur("Navy", 12, "000080"),
     new Couleur("OldLace", 119, "FDF5E6"),
//     new Couleur("Olive", 
     new Couleur("OliveDrab", 57, "6B8E23"),
     new Couleur("Orange", 82, "FFA500"),
     new Couleur("OrangeRed", 87, "FF4500"),
     new Couleur("Orchid", 100, "DA70D6"),
     new Couleur("PaleGoldenrod", 59, "EEE8AA"),
     new Couleur("PaleGreen", 45, "98FB98"),
     new Couleur("PaleTurquoise", 28, "AFEEEE"),
     new Couleur("PaleVioletRed", 93, "DB7093"),
     new Couleur("PapayaWhip", 117, "FFEFD5"),
     //new Couleur("PeachStuff", 
     new Couleur("PeachPuff", 120, "FFDAB9"),   // ??
     new Couleur("Peru", 70, "CD853F"),
     new Couleur("Pink", 91, "FFC0CB"), 
     new Couleur("Plum", 99, "DDA0DD"),
     new Couleur("PowderBlue", 27, "B0E0E6"),
     new Couleur("Purple", 106, "800080"),
     new Couleur("Red", 88, "FF0000"),
     new Couleur("RosyBrown", 66, "BC8F8F"),
     new Couleur("RoyalBlue", 18, "4169E1"),
     new Couleur("SaddleBrown", 68, "8B4513"), 
     new Couleur("Salmon", 80, "FA8072"),
     new Couleur("SandyBrown", 74, "F4A460"),
     new Couleur("SeaGreen", 42, "2E8B57"),
     new Couleur("SeaShell", 126, "FFF5EE"),  
     new Couleur("Sienna", 69, "A0522D"),
     new Couleur("Silver", 8, "C0C0C0"),
     new Couleur("SkyBlue", 22, "87CEEB"),
     new Couleur("SlateBlue", 15, "6A5ACD"),
     new Couleur("SlateGray", 6, "708090"), // ??
     new Couleur("Snow", 109, "FFFAFA"),
     new Couleur("SpringGreen", 47, "00FF7F"),
     new Couleur("SteelBlue", 24, "4682B4"),
     new Couleur("Tan", 75, "D2B48C"),
     new Couleur("Teal", 39, "008080"),
     new Couleur("Thistle", 108, "D8BFD8"),
     new Couleur("Tomato", 86, "FF6347"),
     new Couleur("Turquoise", 31, "40E0D0"),
     new Couleur("Violet", 98, "EE82EE"),
     new Couleur("Wheat", 73, "F5DEB3"),
     new Couleur("White", 134, "FFFFFF"),
     new Couleur("WhiteSmoke", 111, "F5F5F5"),
     new Couleur("Yellow", 62, "FFFF00"),
     new Couleur("YellowGreen", 54, "9ACD32")
    };

  private void Form1_Load(object sender, EventArgs e)
  {
   CritreTri = 1;
   Array.Sort(tabCoul);

   LI = tabCoul.Length / COL + (tabCoul.Length % COL == 0 ? 0 : 1);
   ClientSize = new Size(COL * WCell, LI * HCell);

   AutoScrollMinSize = new Size(COL * WCell, LI * HCell);
   CenterToScreen();
   MaximumSize = new Size(COL * WCell + 70, LI * HCell + 50);
   Text = "Couleurs tries par nuance";

  }

  private void Form1_Paint(object sender, PaintEventArgs e)
  {
   Rectangle[] tabRect = new Rectangle[LI * COL];
   for (int li = 0; li < LI; li++)
    for (int col = 0; col < COL; col++)
    {
     Rectangle r = new Rectangle(col * WCell + AutoScrollPosition.X,
                                 li * HCell + AutoScrollPosition.Y, WCell, HCell);

     if (li * COL + col < tabCoul.Length)
     {
      Color c = Color.FromName(tabCoul[li * COL + col].NomCouleur);
      e.Graphics.FillRectangle(new SolidBrush(c), r);
     }
    }
  }

  private void Form1_MouseMove(object sender, MouseEventArgs e)
  {
   int col = (e.X - AutoScrollPosition.X) / WCell, li = (e.Y - AutoScrollPosition.Y) / HCell;
   string s = "";
   if (li * COL + col < tabCoul.Length)
    s = tabCoul[li * COL + col].NomCouleur + " (" + tabCoul[li * COL + col].ValHexa + ")";
   ttCouleur.SetToolTip(this, s);
  }

  public static int CritreTri = 2;  // 1 : par nom et 2 : par nuance 
  private void mnuParNuance_Click(object sender, System.EventArgs e)
  {
   mnuParNom.Checked = false;
   mnuParNuance.Checked = true;
   CritreTri = 2;
   Array.Sort(tabCoul);
   Invalidate(false);
   Text = "Couleurs tries par nuance";
  }

  private void mnuParNom_Click(object sender, System.EventArgs e)
  {
   mnuParNom.Checked = true;
   mnuParNuance.Checked = false;
   CritreTri = 1;
   Array.Sort(tabCoul);
   Invalidate(false);
   Text = "Couleurs tries par nom";
  }
 }
}